import 'package:yoshi_papas_app/models/producto_model.dart';
import 'package:yoshi_papas_app/models/toping_model.dart';

import 'basico_model.dart';

class PedidoProducto extends Basico {
  int? idPedido;
  int? idProducto;
  Producto? producto;
  String? costoUnitario;
  String? descuento;
  int? cantidad;
  int? terminar;
  String? comentario;
  //List<Map<String, dynamic>>? topings;

  PedidoProducto({
    super.id,
    this.idPedido,
    this.idProducto,
    this.producto,
    this.costoUnitario,
    this.descuento,
    this.cantidad,
    this.terminar,
    this.comentario,
    //this.topings = const [],
  });

  @override
  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'idPedido': idPedido,
      'idProducto': idProducto,
      'costoUnitario': costoUnitario,
      'descuento': descuento,
      'cantidad': cantidad,
      'terminar': terminar,
      'comentario': comentario,
      //'topings': topings,
    }..addAll(super.toJson());
  }

  PedidoProducto.fromJson(Map<String, dynamic> json) {
    super.parseJson(json);
    idPedido = Basico.parseInt(json['idPedido']);
    idProducto = Basico.parseInt(json['idProducto']);
    producto =
        json['producto'] != null ? Producto.fromJson(json['producto']) : null;
    costoUnitario = Basico.parseString(json['costoUnitario']);
    descuento = Basico.parseString(json['descuento']);
    cantidad = Basico.parseInt(json['cantidad']);
    terminar = Basico.parseInt(json['terminar']);
    comentario = Basico.parseString(json['comentario']);
    // topings = (json['topings'] as List<dynamic>?)
    //         ?.map((toping) =>
    //             {'id': toping['id'], 'cantidad': toping['cantidad']})
    //         .toList() ??
    //     [];
  }
}
