import 'package:sqflite/sqflite.dart';
import 'package:yoshi_papas_app/services/repo_service.dart';

import '../models/models.dart';

class ProductosService {
  Future<bool> isDatabaseEmpty() async {
    final dbClient = await RepoService().db;
    final categoriaCount = Sqflite.firstIntValue(
      await dbClient!.rawQuery('SELECT COUNT(*) FROM CategoriaProducto'),
    );
    final productoCount = Sqflite.firstIntValue(
      await dbClient.rawQuery('SELECT COUNT(*) FROM Producto'),
    );
    return categoriaCount == 0 && productoCount == 0;
  }

  Future<void> fillCategoriaBD() async {
    final List<CategoriaProducto> categorias = [
      CategoriaProducto(id: 1, nombre: 'HAMBURGUESA DE POLLO'),
      CategoriaProducto(id: 2, nombre: 'ESPECIALIDADES'),
      CategoriaProducto(id: 3, nombre: 'POSTRES'),
      CategoriaProducto(id: 4, nombre: 'BEBIDAS'),
    ];

    for (var categoria in categorias) {
      await categoria.guardar();
    }
  }

  Future<void> fillProductoBD() async {
    List<Producto> productos = [
      //Snacks
      Producto(
          id: 1, idCategoria: 1, nombre: 'HAMBURGUESA DE POLLO', precio: '110'),
      Producto(
          id: 2, idCategoria: 2, nombre: 'CONO FIT MEDIANO', precio: '120'),
      Producto(id: 3, idCategoria: 3, nombre: 'MUFFIN', precio: '35'),
      Producto(id: 4, idCategoria: 4, nombre: 'COCA COLA 600ML', precio: '25'),
      Producto(id: 5, idCategoria: 4, nombre: 'AGUA', precio: '20'),
    ];

    for (var producto in productos) {
      await producto.guardar();
    }
  }
}
